=begin
TIG (c) 2011
unhideall.rb
Usage:
Tools menu >> Unhide All ...
Unhides everything in the selection or the model AND definitions if 
there's no selection!
Warning dialog to warn...
One step undoable.
Donations:
via PayPal.com to info @ revitrev.org
Version:
1.0 20110922 First issue.
=end
require 'sketchup.rb'
module TIG
def self.unhideall(ss=nil,internal=false)
  model=Sketchup.active_model
  model.start_operation('UnhideAll!') if not internal
  UI.beep if not internal
  if not ss or not ss[0]
    return nil unless UI.messagebox("Unhide All:\n\ni.e. EVERYTHING in the Model,\nincluding ALL Geometry,\n AND inside ALL Groups and Components ?",MB_YESNO,"")==6
    model.entities.each{|e|e.hidden=nil}
    model.definitions.each{|d|d.entities.each{|e|e.hidden=nil}}
  else
    (return nil unless UI.messagebox("Unhide All:\n\n in the Selected Geometry/Groups/Component-Definitions ?",MB_YESNO,"")==6) if not internal
    ss.each{|e|
      e.hidden=nil
      if e.class==Sketchup::Group
        next if not e.entities[0]
        self.unhideall(e.entities, true)
      elsif e.class==Sketchup::ComponentInstance
        next if not e.definition.entities[0]
        self.unhideall(e.definition.entities, true)
      end#if
    }
  end
  model.commit_operation if not internal
end
### menu
if not file_loaded?(__FILE__)
   UI.menu("Tools").add_item("Unhide All"){TIG.unhideall(Sketchup.active_model.selection)}
end
file_loaded(__FILE__)
end#module
